<template>
  <v-navigation-drawer
    id="core-navigation-drawer"
    v-model="drawer"
    :dark="barColor !== 'rgba(228, 226, 226, 1), rgba(255, 255, 255, 0.7)'"
    :expand-on-hover="expandOnHover"
    :right="$vuetify.rtl"
    :src="barImage"
    mobile-breakpoint="960"
    app
    width="210"
    v-bind="$attrs"
  >
    <template v-slot:img="props">
      <v-img
        :gradient="`to bottom, ${barColor}`"
        v-bind="props"
      />
    </template>

    <v-divider class="mb-1" />

    <v-list
      dense
      nav
    >
      <v-list-item>
        <v-list-item-avatar
          class="align-self-center"
          color="white"
          contain
        >
          <v-img
            src="https://demos.creative-tim.com/vuetify-material-dashboard/favicon.ico"
            max-height="30"
          />
        </v-list-item-avatar>

        <v-list-item-content>
          <v-list-item-title
            class=""
          >
            LMS
          </v-list-item-title>
        </v-list-item-content>
      </v-list-item>
    </v-list>
    <v-divider class="mb-2" />
    <v-list
      expand
      nav
    >
      <v-list-item
        link
        v-for="item in $store.getters.getNavigationList"
        :key="item.title"
        :to="item.to"
      >
        <v-list-item-icon>
          <v-icon>{{ item.icon }}</v-icon>
        </v-list-item-icon>
        <v-list-item-content>
          <v-list-item-title>{{ item.title }}</v-list-item-title>
        </v-list-item-content>
      </v-list-item>
      <div />
    </v-list>
    <template v-slot:append>
      <v-list-item
        v-show="show"
        link
        v-on:click="action"
      >
        <v-list-item-icon>
          <v-icon>mdi-logout</v-icon>
        </v-list-item-icon>
        <v-list-item-content>
          <v-list-item-title>{{ portalName }}</v-list-item-title>
        </v-list-item-content>
      </v-list-item>
    </template>
  </v-navigation-drawer>
</template>

<script>
// Utilities
import { getCurrentUser } from '@/firebase/db';

export default {
  name: 'DashboardCoreDrawer',
  props: {
    expandOnHover: {
      type: Boolean,
      default: false,
    },
  },
  data: () => ({
    portalName: '',
    temp: true,
    show: false,
    barColor: 'rgba(0, 0, 0, .8), rgba(0, 0, 0, .8)',
    barImage: 'https://demos.creative-tim.com/material-dashboard/assets/img/sidebar-1.jpg',
  }),
  mounted() {
    getCurrentUser().getIdTokenResult().then((idTokenResult) => {
      if (idTokenResult.claims.admin || idTokenResult.claims.manager) {
        this.$store.dispatch('setNavigationList', this.$store.state.adminMenu);
        this.show = true;
        this.portalName = 'access my portal';
      } else {
        this.$store.dispatch('setNavigationList', this.$store.state.employeeMenu);
        this.show = false;
      }
    });
  },
  computed: {
    drawer: {
      get() {
        return this.$store.state.drawer;
      },
      set(val) {
        this.$store.commit('SET_DRAWER', val);
      },
    },
  },
  methods: {
    action() {
      if (this.temp) {
        this.$router.replace({ name: 'EmployeeInfo' });
        this.$store.dispatch('setNavigationList', this.$store.state.employeeMenu);
        this.temp = false;
        this.portalName = 'admin access';
      } else {
        this.$router.replace({ name: 'home' });
        this.$store.dispatch('setNavigationList', this.$store.state.adminMenu);
        this.temp = true;
        this.portalName = 'access my portal';
      }
    },
  },
};
</script>
